var async = require('async');
var should = require('should');
var add = require('../index');
var readFile = require('imacros-read-file');

runTests(runTestsCallback);


function runTestsCallback(err, reply) {
  if (err) {
    alert('check test suite fails with error: ' + JSON.stringify(err));
    return false;
  }
  iimDisplay('Success! Checks test suite passes');
}

function runTests(cb) {
  var filePath = 'file:///users/noah/src/node/docparse/scrapers/imacros/add/test/config.json';
  loadJSONFile(filePath, function (err, config) {
    if (err) { return cb(err); }
    addNGEDocument(config, cb);
  });
}

function addNGEDocument(config, cb) {
  iimDisplay('adding ngrid electric nge document');
  var filePath = 'file:///users/noah/src/node/docparse/scrapers/imacros/nge/bill-row/test/data/compSupply.json';
  loadJSONFile(filePath, function (err, supplyData) {
    if (err) { return cb(err); }
    if (!supplyData || !supplyData.textPages) {
      return cb('failed to load test file at path: ' + filePath);
    }
    var filename = "NGE_Electronic_2013-02-07_12-36-33_490.pdf";
    var folderPath =  "~/Downloads/scrapers/";
    var data = {
      billNumber: "540a9204737a2a5ee36ec52d1c037b07",
      billDate: "2013 01 22",
      fromDate: "2012 12 18",
      toDate: "2013 01 18",
      accountNumber: "0303560054",
      supplierCode: "NGE",
      hash: supplyData.hash,
      textPages: supplyData.textPages,
      customerID:"50c00afa3723540000000010",
      loginID:"50c00afa3723540000000015",
      supplierID:"50c00af9372354000000000b",
      config: config
    };
    add(data, function (err) {
      if (err) { return cb(err); }
      cb();
    });
  });
}

function loadJSONFile(filePath, cb) {
  readFile(filePath, function (err, reply) {
    if (err) { return cb(err); }
    var data = JSON.parse(reply);
    cb(null, data);
  });
}
